var nSplitterWidth;
var nMediaDuration;
var nTimeFormat;
var nPrgSliderRange;
var curMedianDur;
var bEQViewOpened = false;
var bplViewOpened = false;
function UpdateUI()
{
	if(plist.itemCount < 2)
	{
		btnPrev.enabled = false;
		btnNext.enabled = false;
	}
	else
	{
		btnPrev.enabled = true;
		btnNext.enabled = true;
	}
	if(plist.itemCount > 0)
	{
		btnPlay.enabled=true;
	}
	else
	{
		btnPlay.enabled=false;
	}	
}


function OnLeaveFullScreen()
{
	OnVolumeChanged();
}

function OnMouseWheel(delta)
{
	player.settings.volume = player.settings.volume + delta / 12;
}

function OnMax()
{
	mainview.maximize();
	btnMax.visible=false;
	btnRestore.visible=true;
}

function OnRestore()
{
	mainview.restore();
	btnMax.visible=true;
	btnRestore.visible=false;
}


function OnLButtonDblClk()
{
	if(mainview.IsWindowMaximized)
	{
		OnRestore();
	}
	else
	{
		OnMax();
	}
}

function OnLoad()
{
	var PLPaneOpened = theme.loadPreference('PLPaneOpen');
	if(PLPaneOpened == 'true')
	{
		OpenPList();
	}

	UpdateUI();
	nPrgSliderRange = sliderprogress.range;
	
	OnPlayStatusChanged(player.playState);
	sliderprogress.currentPos = (player.controls.currentPos * nPrgSliderRange) / nMediaDuration;

	preset.text = player.EqualizerSettings.currentPreset;
	updateEQUI();
	eqsliderbalance.currentPos=player.settings.balance;
	eqvoiceboost.currentPos=player.EqualizerSettings.boostVoice;
}

function OnPlay()
{
	var playstate = player.playState;
	if(playstate == 5)	//pause
	{
		player.controls.play();
	}
	else
	{
		var item = plist.selectedItem;
		if(!item)
		{
			item = plist.next;
		}
		
		player.url = item;
	}
}

function OnProgressChange()
{
	if(nTimeFormat == 0)	//KT_FRAME
	{
		var curFrame = Math.round(sliderprogress.currentPos * nMediaDuration / nPrgSliderRange);
		sliderprogress.toolTip = curFrame.toString();
	}
	else
	{	
		var curTime = sliderprogress.currentPos * nMediaDuration / nPrgSliderRange / 1000;
		var timeString;
		curTime = Math.round(curTime);
		var hours = Math.round(curTime / 3600 - 0.5);		
		var mins = Math.round((curTime % 3600) / 60 - 0.5);
		var secs = Math.round((curTime % 3600) % 60 - 0.5);
		sliderprogress.toolTip = hours.toString() + ':' + mins.toString() + ':' + secs.toString();
	}	
}

function OnVolumeSliderChange()
{
	slidervoice.toolTip=slidervoice.currentPos.toString();
	player.settings.volume=slidervoice.currentPos;
	player.EqualizerSettings.boostVoice=100;
}

function OnAudioPluginSetup()
{
	//btnopeneq.enabled=true;
	eqvoiceboost.currentPos = 100;
}

function OnItemDeleted()
{
	UpdateUI();
}

function OnItemAdded(index)
{
	UpdateUI();
}

function OnPlayingItemDeleted()
{
	player.controls.stop();
}

function OnMuteChanged(){btnMute.down=player.settings.mute;}

function OnClose()
{
}

function Setplaymode()
{
	menu.show("playmode");
}

function SelectSkin()
{
	menu.show("skinlist");
}

function CloseKuree()
{
	mainview.close();
}

function playclick()
{
	btnPlay.visible=false;
}

function hidePlayList()
{
	nSplitterWidth = plpane.width;
	splitter.moveTo(playarea.width - 3, 0, 0);
	HidePl.visible=false;
	ShowPl.visible=true;
	theme.savePreference('plhiden', 'true');
}

function showPlayList()
{
	var nPlittereft = playarea.width - nSplitterWidth - 3;
	splitter.moveTo(nPlittereft, 0, 0);
	HidePl.visible=true;
	ShowPl.visible=false;
	theme.savePreference('plhiden', 'false');
}

function OnCapture(savepath)
{
	if(savepath.length > 0)
	{
		savepath = '·:' + savepath;
		playstatus.flashText(savepath, 3000);
	}
	else
	{
		playstatus.flashText('ʧ', 3000);
	}
}

function printScreen()
{
	player.userPrintScreen(0);
}

function OnVideoChanged(width, height)
{
	if(!player.fullScreen && !mainview.isWindowMaximized)
	{
		mainview.width = mainview.width + (width - vid.width);
		mainview.height = mainview.height + (height - vid.height);
		btnFullScreen.enabled=true;
		btnprintscreen.enabled=true;
	}
}

function OnPlayStatusChanged(eStatus)
{
	switch(eStatus)
	{
		case 1:	//PS_Opened
		{
			sliderprogress.currentPos=0;
		}
		break;
		case 4:	//PS_Playing
		{
			//var arr = player.url.split('\\');
			//mainview.viewText = arr[arr.length - 1];
			//title.text="---" + arr[arr.length - 1];
			btnslowdown.enabled=true;
			btnspeedup.enabled=true;
			btnrestorespeed.enabled=true;
			btnStop.enabled=true;
			if(player.hasVideo)
			{
				btnFullScreen.enabled=true;
				btnprintscreen.enabled=true;
			}
			else
			{
				btnFullScreen.enabled=false;
				btnprintscreen.enabled=false;
			}
						
			nMediaDuration = player.duration;	//currentMedia.
			nTimeFormat = player.timeFormat;
			if(nMediaDuration > 0)
			{
				sliderprogress.enabled=true;
			}			
			btnPlay.enabled=true;
			btnPlay.visible=false;
			btnPause.visible=true;
		}
		break;
		case 5:	//PS_Pause
		{
			btnslowdown.enabled=true;
			btnspeedup.enabled=true;
			btnrestorespeed.enabled=true;
			btnPlay.enabled=true;
			btnStop.enabled=true;
			btnPlay.visible=true;
			btnPause.visible=false;
			if(player.hasVideo)
			{
				btnFullScreen.enabled=true;
				btnprintscreen.enabled=true;
			}			
			sliderprogress.enabled=true;
			nMediaDuration = player.duration;	//currentMedia.
		}
		break;
		case 6:	//PS_Stopped
		{
			sliderprogress.currentPos=0;
			//mainview.viewText = 'Ӱ';
			//title.text = "";
			btnPlay.visible=true;
			btnPause.visible=false;
			btnStop.enabled=false;
			btnPlay.enabled=false;
			sliderprogress.enabled=false;
			btnslowdown.enabled=false;
			btnspeedup.enabled=false;
			btnrestorespeed.enabled=false;
			btnFullScreen.enabled=false;
			btnprintscreen.enabled=false;
			UpdateUI();
		}
		break;
	}
}

function OnProgress(nPos, nDur)
{
	sliderprogress.currentPos = (nPos * nPrgSliderRange) / nDur;
}

function OpenMediaDlg()
{
	var newFile = theme.openDialog('DT_MEDIAFILE', '');
	if(newFile)
	{
		plist.deleteAll();
		var nCount = newFile.length;
		for(var i = 0; i < nCount; i++)
		{
			plist.addItem(newFile.item(i));
		}
		player.URL = newFile.item(0);
		newFile="";
	}
}

function OpenPlaylistDlg()
{
	newFile=theme.openDialog('DT_MEDIAFILE','');
	if(newFile)
	{
		var nCount = newFile.length;
		for(var i = 0; i < nCount; i++)
		{
			plist.addItem(newFile.item(i));
		}
	}		
}

function DeletItemFromList()
{
     plist.deleteSelected();
}

function OnProgressDragEnd(nPos)
{
	var nCurPos = nPos * nMediaDuration / nPrgSliderRange;
	player.controls.currentPos = nCurPos;
	sliderprogress.toolTip = 'Ž';
}

function OnVolumeChanged()
{
	slidervoice.currentPos=player.settings.volume;
	slidervoice.toolTip = slidervoice.currentPos.toString();
	eqvoiceboost.currentPos=100;
	eqvoiceboost.toolTip = eqvoiceboost.currentPos.toString() + '%';
}

function OnError(errorInfo)
{
	sliderprogress.currentPos = 0;
}
function OpenUrl(strUrl)
{
	theme.launchURL(strUrl);

}

function OnTextChange1(adStr)
{
	if(adStr.length > 0)
	{
		ScrollTextbk1.visible = true;
		st1.scrollText(adStr, 5);
	}
	else
	{
		ScrollTextbk1.visible = false;
	}	

	ScrollTextbk1.relayoutControl();
}

function plpheight()
{
	if(ScrollTextbk2.visible) 
	{
		return plistrect.height-47;
	}
	else 
	{
		return plistrect.height-20;
	}
}

function OnTextChange2(adStr)
{
	if(adStr.length > 0)
	{
		ScrollTextbk2.visible = true;
		st2.scrollText(adStr, 5);
	}
	else
	{
		ScrollTextbk2.visible = false;
	}	
	
	playarea.relayoutControl();	
}
function plistviewTop()
{
	if(bplViewOpened)
	{
		return mainview.height - 157;
	}
	else
	{
		return mainview.height- 314;
	}
}
function OpenPList()
{
	if (bplViewOpened) 
	{
		theme.savePreference('PLPaneOpen', 'false');
		plist.visible = false;
		plistview.moveTo(82, mainview.height-314, 100);
		HidePl.visible=true;
		ShowPl.visible=false;
		bplViewOpened = false;

	}
	else 
	{
		theme.savePreference('PLPaneOpen', 'true');
		plist.visible = true;
		plistview.moveTo(82, mainview.height-157, 100);
		HidePl.visible=false;
		ShowPl.visible=true;
		bplViewOpened = true;
	}
}

//

function CloseEqView()
{	
 	theme.savePreference( 'vwEQOpened', 'false' ); 
 	theme.closeView('eqview');
	var mainJsCtx = theme.javascriptContext('mainview');
	if(mainJsCtx)
	{
		mainJsCtx.ExecuteStatement('btnopeneq.down=false;');
		mainJsCtx.ExecuteStatement('bEQViewOpened=false;');
	}
}

function EQSelectMenu()
{
    var index = 0;
    var max = player.EqualizerSettings.presetCount;

    mnuEQSelect.deleteAll();

    for (index=0; index<max; index++)
    {
        mnuEQSelect.AppendItem( player.EqualizerSettings.presetTitle(index) );
    }
    
    mnuEQSelect.selectedItem = player.EqualizerSettings.currentPreset;
    mnuEQSelect.show();
    preset.text = player.EqualizerSettings.currentPreset;
}

function OnSelectedItemChange()
{
	player.EqualizerSettings.currentPreset = mnuEQSelect.selectedItem;
	updateEQUI();
}

function updateEQUI()
{
	eqslider0.currentPos = player.EqualizerSettings.gainLevel(0)/100;
	eqslider1.currentPos = player.EqualizerSettings.gainLevel(1)/100;
	eqslider2.currentPos = player.EqualizerSettings.gainLevel(2)/100;
	eqslider3.currentPos = player.EqualizerSettings.gainLevel(3)/100;
	eqslider4.currentPos = player.EqualizerSettings.gainLevel(4)/100;
	eqslider5.currentPos = player.EqualizerSettings.gainLevel(5)/100;
	eqslider6.currentPos = player.EqualizerSettings.gainLevel(6)/100;
	eqslider7.currentPos = player.EqualizerSettings.gainLevel(7)/100;
	eqslider8.currentPos = player.EqualizerSettings.gainLevel(8)/100;
	eqslider9.currentPos = player.EqualizerSettings.gainLevel(9)/100;
	eqslider0.toolTip=eqslider0.currentPos.toString();
	eqslider1.toolTip=eqslider1.currentPos.toString();
	eqslider2.toolTip=eqslider2.currentPos.toString();
	eqslider3.toolTip=eqslider3.currentPos.toString();
	eqslider4.toolTip=eqslider4.currentPos.toString();
	eqslider5.toolTip=eqslider5.currentPos.toString();
	eqslider6.toolTip=eqslider6.currentPos.toString();
	eqslider7.toolTip=eqslider7.currentPos.toString();
	eqslider8.toolTip=eqslider8.currentPos.toString();
	eqslider9.toolTip=eqslider9.currentPos.toString();
}


function loadEq()
{
	newFile = theme.openDialog('DT_EQFILE', '');
	if(newFile)
	{
		player.EqualizerSettings.loadEqualizer(newFile.item(0));
		preset.text = 'Զ';
		updateEQUI();
	}
}

function saveEq()
{
	newFile = theme.openDialog('DT_EQFILE', 'save');
	if(newFile)
	{
		player.EqualizerSettings.saveEqualizer(newFile.item(0));
	}
}

function EqReset()
{
	for(i = 0; i < 10; i++)
	{
		player.EqualizerSettings.gainLevel(i) = 0;
	}
	
    	player.EqualizerSettings.currentPreset = 'Ĭ';
	preset.text = 'Ĭ';
	updateEQUI();
}

function OnBalanceChanged()
{
	eqsliderbalance.currentPos=player.settings.balance;
	eqsliderbalance.toolTip = eqsliderbalance.currentPos.toString();
}

function OnEqValueChange(nIndex, slider)
{
	preset.text = 'Զ';
	slider.toolTip=slider.currentPos.toString();
	player.EqualizerSettings.gainLevel(nIndex)=slider.currentPos*100;
}

